
#include "c8051.h"

#define SYSCLK      (24500000 / 8)

#define LED P0_2

void timer2_handler(void) interrupt 5
{
	TF2H = 0;
	LED = ~LED;
}

void init_timer2(int counts)
{
	unsigned short countsL = -counts;
	unsigned short countsH = -counts;
	countsH >>= 8;

	TMR2CN = 0x00;
	CKCON &= ~0x60;

	TMR2RLL = countsL;
	TMR2RLH = countsH;
	TMR2L = 0xff;
	TMR2H = 0xff;
	ET2 = 1;
	TR2 = 1;
}



void main(void)
{
	PCA0MD = 0x00;

	// initialize system clock
	OSCICN = 0x04;		// oscillator divided by 8
	RSTSRC = 0x04;

	// initialize I/O port
	XBR0 = 0x04;
	XBR1 = 0x00;
	XBR2 = 0x40;
	P0MDOUT |= 0x04;

	init_timer2(SYSCLK / 12 / 10);

	EA = 1;

	while (1);
}
